// **********************************************************************
//
// Copyright (c) 2003-2016 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.6.3
//
// <auto-generated>
//
// Generated from file `RawFileStore.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Raw file gateway which provides access to the OMERO file repository.
 *
 * Note: methods on this service are protected by a ""DOWNLOAD"" restriction.
 *
 * See also <a href="http://downloads.openmicroscopy.org/latest/omero5.2/api/ome/api/RawFileStore.html">RawFileStore.html</a>
 **/
public interface RawFileStorePrx extends StatefulServiceInterfacePrx
{
    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is in
     * place.
     **/
    public void setFileId(long fileId)
        throws omero.ServerError;

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is in
     * place.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setFileId(long fileId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is in
     * place.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId);

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is in
     * place.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, java.util.Map<String, String> __ctx);

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is in
     * place.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, Ice.Callback __cb);

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is in
     * place.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is in
     * place.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, Callback_RawFileStore_setFileId __cb);

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is in
     * place.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, java.util.Map<String, String> __ctx, Callback_RawFileStore_setFileId __cb);

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is in
     * place.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, 
                                           IceInternal.Functional_VoidCallback __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is in
     * place.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, 
                                           IceInternal.Functional_VoidCallback __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                           IceInternal.Functional_BoolCallback __sentCb);

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is in
     * place.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, 
                                           java.util.Map<String, String> __ctx, 
                                           IceInternal.Functional_VoidCallback __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is in
     * place.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, 
                                           java.util.Map<String, String> __ctx, 
                                           IceInternal.Functional_VoidCallback __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                           IceInternal.Functional_BoolCallback __sentCb);

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is in
     * place.
     * @param __result The asynchronous result object.
     **/
    public void end_setFileId(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the current file id or null if none has been set.
     **/
    public omero.RLong getFileId()
        throws omero.ServerError;

    /**
     * Returns the current file id or null if none has been set.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.RLong getFileId(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the current file id or null if none has been set.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileId();

    /**
     * Returns the current file id or null if none has been set.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileId(java.util.Map<String, String> __ctx);

    /**
     * Returns the current file id or null if none has been set.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileId(Ice.Callback __cb);

    /**
     * Returns the current file id or null if none has been set.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileId(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the current file id or null if none has been set.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileId(Callback_RawFileStore_getFileId __cb);

    /**
     * Returns the current file id or null if none has been set.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileId(java.util.Map<String, String> __ctx, Callback_RawFileStore_getFileId __cb);

    /**
     * Returns the current file id or null if none has been set.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileId(IceInternal.Functional_GenericCallback1<omero.RLong> __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Returns the current file id or null if none has been set.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileId(IceInternal.Functional_GenericCallback1<omero.RLong> __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                           IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Returns the current file id or null if none has been set.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileId(java.util.Map<String, String> __ctx, 
                                           IceInternal.Functional_GenericCallback1<omero.RLong> __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    /**
     * Returns the current file id or null if none has been set.
     * @param __ctx The Context map to send with the invocation.
     * @param __responseCb The lambda response callback.
     * @param __userExceptionCb The lambda user exception callback.
     * @param __exceptionCb The lambda exception callback.
     * @param __sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileId(java.util.Map<String, String> __ctx, 
                                           IceInternal.Functional_GenericCallback1<omero.RLong> __responseCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                           IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                           IceInternal.Functional_BoolCallback __sentCb);

    /**
     * Returns the current file id or null if none has been set.
     * @param __result The asynchronous result object.
     **/
    public omero.RLong end_getFileId(Ice.AsyncResult __result)
        throws omero.ServerError;

    public byte[] read(long position, int length)
        throws omero.ServerError;

    public byte[] read(long position, int length, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_read(long position, int length);

    public Ice.AsyncResult begin_read(long position, int length, java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_read(long position, int length, Ice.Callback __cb);

    public Ice.AsyncResult begin_read(long position, int length, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_read(long position, int length, Callback_RawFileStore_read __cb);

    public Ice.AsyncResult begin_read(long position, int length, java.util.Map<String, String> __ctx, Callback_RawFileStore_read __cb);

    public Ice.AsyncResult begin_read(long position, 
                                      int length, 
                                      IceInternal.Functional_GenericCallback1<byte[]> __responseCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    public Ice.AsyncResult begin_read(long position, 
                                      int length, 
                                      IceInternal.Functional_GenericCallback1<byte[]> __responseCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                      IceInternal.Functional_BoolCallback __sentCb);

    public Ice.AsyncResult begin_read(long position, 
                                      int length, 
                                      java.util.Map<String, String> __ctx, 
                                      IceInternal.Functional_GenericCallback1<byte[]> __responseCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    public Ice.AsyncResult begin_read(long position, 
                                      int length, 
                                      java.util.Map<String, String> __ctx, 
                                      IceInternal.Functional_GenericCallback1<byte[]> __responseCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                      IceInternal.Functional_BoolCallback __sentCb);

    public byte[] end_read(Ice.AsyncResult __result)
        throws omero.ServerError;

    public long size()
        throws omero.ServerError;

    public long size(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_size();

    public Ice.AsyncResult begin_size(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_size(Ice.Callback __cb);

    public Ice.AsyncResult begin_size(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_size(Callback_RawFileStore_size __cb);

    public Ice.AsyncResult begin_size(java.util.Map<String, String> __ctx, Callback_RawFileStore_size __cb);

    public Ice.AsyncResult begin_size(IceInternal.Functional_LongCallback __responseCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    public Ice.AsyncResult begin_size(IceInternal.Functional_LongCallback __responseCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                      IceInternal.Functional_BoolCallback __sentCb);

    public Ice.AsyncResult begin_size(java.util.Map<String, String> __ctx, 
                                      IceInternal.Functional_LongCallback __responseCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    public Ice.AsyncResult begin_size(java.util.Map<String, String> __ctx, 
                                      IceInternal.Functional_LongCallback __responseCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                      IceInternal.Functional_BoolCallback __sentCb);

    public long end_size(Ice.AsyncResult __result)
        throws omero.ServerError;

    public boolean truncate(long length)
        throws omero.ServerError;

    public boolean truncate(long length, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_truncate(long length);

    public Ice.AsyncResult begin_truncate(long length, java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_truncate(long length, Ice.Callback __cb);

    public Ice.AsyncResult begin_truncate(long length, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_truncate(long length, Callback_RawFileStore_truncate __cb);

    public Ice.AsyncResult begin_truncate(long length, java.util.Map<String, String> __ctx, Callback_RawFileStore_truncate __cb);

    public Ice.AsyncResult begin_truncate(long length, 
                                          IceInternal.Functional_BoolCallback __responseCb, 
                                          IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                          IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    public Ice.AsyncResult begin_truncate(long length, 
                                          IceInternal.Functional_BoolCallback __responseCb, 
                                          IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                          IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                          IceInternal.Functional_BoolCallback __sentCb);

    public Ice.AsyncResult begin_truncate(long length, 
                                          java.util.Map<String, String> __ctx, 
                                          IceInternal.Functional_BoolCallback __responseCb, 
                                          IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                          IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    public Ice.AsyncResult begin_truncate(long length, 
                                          java.util.Map<String, String> __ctx, 
                                          IceInternal.Functional_BoolCallback __responseCb, 
                                          IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                          IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                          IceInternal.Functional_BoolCallback __sentCb);

    public boolean end_truncate(Ice.AsyncResult __result)
        throws omero.ServerError;

    public void write(byte[] buf, long position, int length)
        throws omero.ServerError;

    public void write(byte[] buf, long position, int length, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_write(byte[] buf, long position, int length);

    public Ice.AsyncResult begin_write(byte[] buf, long position, int length, java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_write(byte[] buf, long position, int length, Ice.Callback __cb);

    public Ice.AsyncResult begin_write(byte[] buf, long position, int length, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_write(byte[] buf, long position, int length, Callback_RawFileStore_write __cb);

    public Ice.AsyncResult begin_write(byte[] buf, long position, int length, java.util.Map<String, String> __ctx, Callback_RawFileStore_write __cb);

    public Ice.AsyncResult begin_write(byte[] buf, 
                                       long position, 
                                       int length, 
                                       IceInternal.Functional_VoidCallback __responseCb, 
                                       IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                       IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    public Ice.AsyncResult begin_write(byte[] buf, 
                                       long position, 
                                       int length, 
                                       IceInternal.Functional_VoidCallback __responseCb, 
                                       IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                       IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                       IceInternal.Functional_BoolCallback __sentCb);

    public Ice.AsyncResult begin_write(byte[] buf, 
                                       long position, 
                                       int length, 
                                       java.util.Map<String, String> __ctx, 
                                       IceInternal.Functional_VoidCallback __responseCb, 
                                       IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                       IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    public Ice.AsyncResult begin_write(byte[] buf, 
                                       long position, 
                                       int length, 
                                       java.util.Map<String, String> __ctx, 
                                       IceInternal.Functional_VoidCallback __responseCb, 
                                       IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                       IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                       IceInternal.Functional_BoolCallback __sentCb);

    public void end_write(Ice.AsyncResult __result)
        throws omero.ServerError;

    public boolean exists()
        throws omero.ServerError;

    public boolean exists(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_exists();

    public Ice.AsyncResult begin_exists(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_exists(Ice.Callback __cb);

    public Ice.AsyncResult begin_exists(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_exists(Callback_RawFileStore_exists __cb);

    public Ice.AsyncResult begin_exists(java.util.Map<String, String> __ctx, Callback_RawFileStore_exists __cb);

    public Ice.AsyncResult begin_exists(IceInternal.Functional_BoolCallback __responseCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    public Ice.AsyncResult begin_exists(IceInternal.Functional_BoolCallback __responseCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                        IceInternal.Functional_BoolCallback __sentCb);

    public Ice.AsyncResult begin_exists(java.util.Map<String, String> __ctx, 
                                        IceInternal.Functional_BoolCallback __responseCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    public Ice.AsyncResult begin_exists(java.util.Map<String, String> __ctx, 
                                        IceInternal.Functional_BoolCallback __responseCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                        IceInternal.Functional_BoolCallback __sentCb);

    public boolean end_exists(Ice.AsyncResult __result)
        throws omero.ServerError;

    public omero.model.OriginalFile save()
        throws omero.ServerError;

    public omero.model.OriginalFile save(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_save();

    public Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_save(Ice.Callback __cb);

    public Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_save(Callback_RawFileStore_save __cb);

    public Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx, Callback_RawFileStore_save __cb);

    public Ice.AsyncResult begin_save(IceInternal.Functional_GenericCallback1<omero.model.OriginalFile> __responseCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    public Ice.AsyncResult begin_save(IceInternal.Functional_GenericCallback1<omero.model.OriginalFile> __responseCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                      IceInternal.Functional_BoolCallback __sentCb);

    public Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx, 
                                      IceInternal.Functional_GenericCallback1<omero.model.OriginalFile> __responseCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb);

    public Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx, 
                                      IceInternal.Functional_GenericCallback1<omero.model.OriginalFile> __responseCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.UserException> __userExceptionCb, 
                                      IceInternal.Functional_GenericCallback1<Ice.Exception> __exceptionCb, 
                                      IceInternal.Functional_BoolCallback __sentCb);

    public omero.model.OriginalFile end_save(Ice.AsyncResult __result)
        throws omero.ServerError;
}
