// **********************************************************************
//
// Copyright (c) 2003-2016 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.6.3
//
// <auto-generated>
//
// Generated from file `RawFileStore.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Raw file gateway which provides access to the OMERO file repository.
 *
 * Note: methods on this service are protected by a ""DOWNLOAD"" restriction.
 *
 * See also <a href="http://downloads.openmicroscopy.org/latest/omero5.2/api/ome/api/RawFileStore.html">RawFileStore.html</a>
 **/
public interface _RawFileStoreOperationsNC extends _StatefulServiceInterfaceOperationsNC
{
    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is in
     * place.
     * @param __cb The callback object for the operation.
     **/
    void setFileId_async(AMD_RawFileStore_setFileId __cb, long fileId)
        throws omero.ServerError;

    /**
     * Returns the current file id or null if none has been set.
     * @param __cb The callback object for the operation.
     **/
    void getFileId_async(AMD_RawFileStore_getFileId __cb)
        throws omero.ServerError;

    void read_async(AMD_RawFileStore_read __cb, long position, int length)
        throws omero.ServerError;

    void size_async(AMD_RawFileStore_size __cb)
        throws omero.ServerError;

    void truncate_async(AMD_RawFileStore_truncate __cb, long length)
        throws omero.ServerError;

    void write_async(AMD_RawFileStore_write __cb, byte[] buf, long position, int length)
        throws omero.ServerError;

    void exists_async(AMD_RawFileStore_exists __cb)
        throws omero.ServerError;

    void save_async(AMD_RawFileStore_save __cb)
        throws omero.ServerError;
}
